local harbour = ...

harbour:registerBehaviorTreeNode({
    Name = HarbourPrefix .. "_NODE",
    VariableList = {
		Var1 = "BEHAVIOR_TREE_DATA_AGENT",
		Var2 = "BEHAVIOR_TREE_DATA_WAIT",
		Var3 = "BEHAVIOR_TREE_DATA_LOCATION",
		GuardingLocation = "BEHAVIOR_TREE_DATA_LOCATION",
		Var4 = "BEHAVIOR_TREE_DATA_RESOURCE_TRANSPORT",
		Var5 = "BEHAVIOR_TREE_DATA_LOOP",
		Var7 = "BEHAVIOR_TREE_DATA_WAIT",
		LandingMessage = "BEHAVIOR_TREE_DATA_STRING",
    },
    Init = function(self, instance)
--		harbour:log("NODE INIT!")
    end,
    Update = function(self, level, instance)
--		harbour:log("NODE UPDATE!")
		return self:updateFunc(level, instance)
    end,
    Finish = function(self, instance)
--		harbour:log("NODE FINISH!")
    end,
    updateFunc = function(self, level, instance)
--		harbour:log("NODE UPDATE FUNC!")
--		harbour:log("Agent data: " .. tostring(self.Var1))
--		harbour:log(tostring(self.Var1.Agent))
--		harbour:log("Agent data owner: " .. tostring(self.Var1.Agent:getOwner()))

		local workplace = self.Var1.Agent:getOwner():getEnabledComponent("COMP_VILLAGER"):getJobInstance().Workplace
		-- No workplace found that matches this job
		if workplace == nil then
			self.Var1.Agent:setBehaviorMessage(foundation.localize("I_CANT_FIND_A_PLACE_TO_WORK"))
                        harbour:log(HarbourPrefix .. "_NODE: workplace == nil")
			return BEHAVIOR_TREE_NODE_RESULT.FALSE
		end
		if (not workplace:isEnabled()) then
			self.Var1.Agent:setBehaviorMessage(foundation.localize("I_CANT_FIND_A_PLACE_TO_WORK"))
                        harbour:log(HarbourPrefix .. "_NODE: workplace not enabled")
			return BEHAVIOR_TREE_NODE_RESULT.FALSE
		end
                local boatComponent = workplace:getOwner():findFirstObjectWithComponentDown(HarbourPrefix .. "_COMP_BOAT")
                if (boatComponent == nil) then
			self.Var1.Agent:setBehaviorMessage(foundation.localize("I_CANT_FIND_A_PLACE_TO_WORK"))
                        harbour:log(HarbourPrefix .. "_NODE: boatComponent not found")
			return BEHAVIOR_TREE_NODE_RESULT.FALSE
		end
                local i = boatComponent:registerAssignedSailor(self.Var1.Agent:getOwner())
                if i <= 0 then
			self.Var1.Agent:setBehaviorMessage(foundation.localize("I_CANT_FIND_A_PLACE_TO_WORK"))
                        harbour:log(HarbourPrefix .. "_NODE: error registerAssignedSailor i=" .. i)
			return BEHAVIOR_TREE_NODE_RESULT.FALSE
		end

                local _guardingLocationComp = boatComponent:getOwner():findFirstObjectWithComponentDown(HarbourPrefix .. "_COMP_GUARDING_LOCATION" .. i)
                if _guardingLocationComp == nil then       
			self.Var1.Agent:setBehaviorMessage(foundation.localize("I_CANT_FIND_A_PLACE_TO_WORK"))
                        harbour:log("_guardingLocationComp == nil")
			return BEHAVIOR_TREE_NODE_RESULT.FALSE
		end
                
                self.GuardingLocation:setDestination(_guardingLocationComp:getOwner(), { 0, 0 }, true)


--                harbour:log("Wait data: " .. tostring(self.Var2))
--		harbour:log("Location data: " .. tostring(self.Var3))
--		harbour:log("Location data destination: " .. tostring(self.Var3.DestinationPosition))
--		harbour:log("Resource transport data: " .. tostring(self.Var4))
--		harbour:log("Loop data: " .. tostring(self.Var5))
		return BEHAVIOR_TREE_NODE_RESULT.TRUE
    end,
})

harbour:registerBehaviorTreeNode({
    Name = HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE",
    VariableList = {
		Var1 = "BEHAVIOR_TREE_DATA_AGENT",
		Var2 = "BEHAVIOR_TREE_DATA_WAIT",
		Var3 = "BEHAVIOR_TREE_DATA_LOCATION",
		Var4 = "BEHAVIOR_TREE_DATA_RESOURCE_TRANSPORT",
		Var5 = "BEHAVIOR_TREE_DATA_LOOP",
		Var7 = "BEHAVIOR_TREE_DATA_WAIT",
    },
    Init = function(self, instance)
--		harbour:log(HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE:  INIT!")
    end,
    Update = function(self, level, instance)
--		harbour:log(HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE:  UPDATE!")
		return self:updateFunc2(level, instance)
    end,
    Finish = function(self, instance)
--		harbour:log(HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE: FINISH!")
    end,
    updateFunc2 = function(self, level, instance)
--		harbour:log("CHECK_BOAT_SAILING UPDATE FUNC!")
--		harbour:log("Agent data: " .. tostring(self.Var1))
--		harbour:log(tostring(self.Var1.Agent))
--		harbour:log("Agent data owner: " .. tostring(self.Var1.Agent:getOwner()))

		local workplace = self.Var1.Agent:getOwner():getEnabledComponent("COMP_VILLAGER"):getJobInstance().Workplace
		-- No workplace found that matches this job
		if workplace == nil then
			self.Var1.Agent:setBehaviorMessage(foundation.localize("I_CANT_FIND_A_PLACE_TO_WORK"))
                        harbour:log(HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE: workplace == nil")
			return BEHAVIOR_TREE_NODE_RESULT.FALSE
		end
		if (not workplace:isEnabled()) then
			self.Var1.Agent:setBehaviorMessage(foundation.localize("I_CANT_FIND_A_PLACE_TO_WORK"))
                        harbour:log(HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE: workplace not enabled")
			return BEHAVIOR_TREE_NODE_RESULT.FALSE
		end
                local boatComponent = workplace:getOwner():findFirstObjectWithComponentDown(HarbourPrefix .. "_COMP_BOAT")
                if (boatComponent == nil) then
			self.Var1.Agent:setBehaviorMessage(foundation.localize("I_CANT_FIND_A_PLACE_TO_WORK"))
                        harbour:log(HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE: boatComponent not found")
			return BEHAVIOR_TREE_NODE_RESULT.FALSE
		end
--                harbour:log(HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE: Call checkBoatSailing()")

                local _result = boatComponent:checkBoatSailing(self.Var1.Agent:getOwner().Name)		
--                if _result == BEHAVIOR_TREE_NODE_RESULT.FALSE then
--                     harbour:log(HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE: checkBoatSailing failed")
--                end
		return _result
    end,
})

harbour:registerBehaviorTree({
	Id = HarbourPrefix .. "_BEHAVIOR_TREE",
	VariableList = {
		{
			Name = "AgentData",
			DataType = "BEHAVIOR_TREE_DATA_AGENT",
			IsPublic = true,
			InitialValue = {} -- Optional if empty, leaves the default values (if any)
		},
		{
			Name = "DoJobTimer",
			DataType = "BEHAVIOR_TREE_DATA_WAIT",
			IsPublic = true,
			InitialValue = {
				TimeToWait = 0,
				Animation = AGENT_ANIMATION.GATHER,
				SetIdleAfterWait = false,
			}
		},
		{
			Name = "DoJobTimerWait",
			DataType = "BEHAVIOR_TREE_DATA_WAIT",
			IsPublic = true,
			InitialValue = {
				TimeToWait = 10.0,
				Animation = AGENT_ANIMATION.IDLE,
			}
		},
		{
			Name = "DoBoolFalse",
			DataType = "BEHAVIOR_TREE_DATA_BOOL",
			IsPublic = true,
			InitialValue = { Value = true }
		},
		{
			Name = "LandingMessage",
			DataType = "BEHAVIOR_TREE_DATA_STRING",
			IsPublic = true,
			InitialValue = { String = HarbourPrefix .. "_LANDING" }
		},
		{
			Name = "WorkplacePosition",
			DataType = "BEHAVIOR_TREE_DATA_LOCATION",
			IsPublic = false,
			InitialValue = {
				CanNavigateOnGround = true,
				CanNavigateOnWater = true,
				IsSetOrientationOnDestination = true,
			}
		},
		{
			Name = "GuardingLocation",
			DataType = "BEHAVIOR_TREE_DATA_LOCATION"
		},
		{
			Name = "TransportData",
			DataType = "BEHAVIOR_TREE_DATA_RESOURCE_TRANSPORT",
			IsPublic = false,
		},
		{
			Name = "WorkLoop",
			DataType = "BEHAVIOR_TREE_DATA_LOOP",
			IsPublic = true,
			InitialValue = {
				LoopCount = 1,
				Duration = 0,
				IsInfinite = true,
				IsDuration = false,
			}
		},
	},
	Root = {
		Name = "WorkingGlobalSequencer",
		Type = "SEQUENCER",
		Children = {
			{
				Name = "NeedFilledSelector",
				Type = "SELECTOR",
				Children = {
					{
						Name = "NeedFilledInverter",
						Type = "INVERTER",
						Child = {
							Name = "IsMyNeedFilled",
							Type = "IS_WORKPLACE_NEED_RESOURCE",
							AgentData = "AgentData",
						}
					},
					{
						Name = "FetchResourceSequencer",
						Type = "SEQUENCER",
						Children = {
							{
								Name = "FindResourceForWorkplace",
								Type = "FIND_RESOURCE_FOR_WORKPLACE",
								AgentData = "AgentData",
								TransportData = "TransportData",
							},
							{
								Name = "Transport",
								Type = "BEHAVIOR_TRANSPORT",
								AgentData = "AgentData",
								TransportData = "TransportData",
							},
						},
					},
				},
			},
			{
				Name = HarbourPrefix .. "_NODE_INSTANCE",
				Type = HarbourPrefix .. "_NODE",
				Var1 = "AgentData",
				Var2 = "DoJobTimer",
				Var3 = "WorkplacePosition",
				Var4 = "TransportData",
				Var5 = "WorkLoop",
				Var7 = "DoJobTimerWait",
                                GuardingLocation = "GuardingLocation"
			},
			{
				Name = "SetupWork",
				Type = "SETUP_WORK",
				AgentData = "AgentData",
				TimeToWait = "DoJobTimer",
				WorkPosition = "WorkplacePosition",
			},
			{
				Name = "GoToResource",
				Type = "GO_TO",
				AgentData = "AgentData",
				Destination = "WorkplacePosition",
				BuildingPathType = "",
				AnimationData = "",
				AnimationSpeedMultiplier = "",
			},
			{
				Name = "GoToLocation1",
				Type = "GO_TO",
				AgentData = "AgentData",
				Destination = "GuardingLocation",
			},
			{
				Name = "SetRotationLocation1",
				Type = "SET_ORIENTATION",
				AgentData = "AgentData",
				Destination = "GuardingLocation",
			},
                        {
			        Name = "StartProduction1",
				Type = "START_PRODUCTION",
				AgentData = "AgentData"
                        },
			{
				Name = "WorkLoopRepeater2",
				Type = "REPEAT_UNTIL_FAIL",
				RepeatData = "WorkLoop",
				Child = {
					Name = "WorkLoopSequencer2",
					Type = "SEQUENCER",
					Children = {

  						{
						        Name = "FinishProduction1", -- to reset the current producing
							Type = "FINISH_PRODUCTION",
							AgentData = "AgentData",
                                                },
 						{
							Name = "StartProduction2", -- Need it to enable again the workplace
							Type = "START_PRODUCTION",
							AgentData = "AgentData"
                                                },
						{
							Name = "IsWorkplaceAvailable3",
							Type = "IS_WORKPLACE_AVAILABLE",
							AgentData = "AgentData"
						},
                                                {
							Name = "WaitCompBoatExecuted",
							Type = "WAIT",
							AgentData = "AgentData",
                         				TimeToWait = "DoJobTimerWait" -- to avoid too much freeze with FINISH_PRODUCTION,
                                                                                      -- but not too long else the sailor produces before the ship reaches back the harbour                                                                                                      -- and the sailor leaves the boat
                                                },
         		                        {
				                        Name = HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE_INSTANCE",
				                        Type = HarbourPrefix .. "_CHECK_BOAT_SAILING_NODE",
				                        Var1 = "AgentData",
				                        Var2 = "DoJobTimer",
				                        Var3 = "WorkplacePosition",
				                        Var4 = "TransportData",
				                        Var5 = "WorkLoop",
	                         			Var7 = "DoJobTimerWait"
			                        },
					}
				}
			},
         		{
				Name = "Landing",
				Type = "SET_ACTIVITY_MESSAGE",
				AgentData = "AgentData",
				Message = "LandingMessage",
			},
                        {
				Name = "ProduceResource", -- For real producing
				Type = "PRODUCE_RESOURCE",
				AgentData = "AgentData",
                        	TimeToWait = "DoJobTimer"
                        },
         		{
				Name = "GettingXp",
				Type = "GIVE_JOB_XP",
				AgentData = "AgentData",
				ShouldReceiveXp = "",
			},
		}
	}
})